GraphicsMagick Search site

- Home
- License
- Mission
- Download
- Installation
- FAQ
- News
- Formats

- Process
- Contribute
- CVS
- Mailing Lists
- ChangeLog
- Report Bugs
- Utilities
- Programming
- Links

# image

## Miscellaneous image methods

Contents

- AccessDefinition
- AddDefinitions
- AllocateImage
- AllocateImageColormap
- AllocateNextImage
- AnimateImages
- AppendImages
- AverageImages
- CatchImageException
- ClipPathImage
- CloneImage
- CloneImageInfo
- CycleColormapImage
- DescribeImage
- DestroyImage
- DestroyImageInfo
- DisplayImages
- GetImageClipMask
- GetImageDepth
- GetImageException
- GetImageCharacteristics
- GetImageGeometry
- GetImageInfo
- GetImageStatistics
- GetImageType
- IsTaintImage
- ModifyImage
- PlasmaImage
- ReferenceImage
- RemoveDefinitions
- ReplaceImageColormap
- SetImage
- SetImageClipMask
- SetImageDepth
- SetImageOpacity
- SetImageType
- TextureImage

# AccessDefinition

## Synopsis

    const char *AccessDefinition( const ImageInfo *image_info, const char *magick,
                                  const char *key );

## Description

AccessDefinition() searches the definitions for an entry matching the specified magick and key. NULL is returned if no matching entry is found.

The format of the AccessDefinition method is:

    const char *AccessDefinition( const ImageInfo *image_info, const char *magick,
                                  const char *key );

image_info:
  The image info.
magick:
  Format ID. This is usually the same as the coder name.
key:
  Key to search for.

# AddDefinitions

## Synopsis

    void AddDefinitions( ImageInfo *image_info, const char *options );

## Description

AddDefinitions() adds definitions from a key/value based string to the current map of definitions in ImageInfo. Definitions may be used by coders/decoders that read and write images.

The format of the AddDefinitions method is:

    void AddDefinitions( ImageInfo *image_info, const char *options );

A description of each parameter follows:

image_info:
  The image info.
options:
  List of key/value pairs to put in the definitions map. The format of the string is "key1[=[value1]],key2[=[value2]],...". A missing value argument (with or without the equal sign) inserts an empty, zero length string as value for a key.
exception:
  Errors result in updates to this structure.

# AllocateImage

## Synopsis

    Image *AllocateImage( const ImageInfo *image_info );

## Description

AllocateImage() returns a pointer to an image structure initialized to default values.

The format of the AllocateImage method is:

    Image *AllocateImage( const ImageInfo *image_info );

A description of each parameter follows:

image_info:
  Many of the image default values are set from this structure. For example, filename, compression, depth, background color, and others.

# AllocateImageColormap

## Synopsis

    unsigned int AllocateImageColormap( Image *image, const unsigned long colors );

## Description

AllocateImageColormap() allocates an image colormap and initializes it to a linear gray colorspace with increasing intensity. If the image already has a colormap, it is replaced. AllocateImageColormap() returns True if successful, otherwise False if there is not enough memory.

The format of the AllocateImageColormap method is:

    unsigned int AllocateImageColormap( Image *image, const unsigned long colors );

image:
  The image.
colors:
  The number of colors in the image colormap.

# AllocateNextImage

## Synopsis

    void AllocateNextImage( const ImageInfo *image_info, Image *image );

## Description

Use AllocateNextImage() to initialize the next image in a sequence to default values. The next member of image points to the newly allocated image. If there is a memory shortage, next is assigned NULL.

The format of the AllocateNextImage method is:

    void AllocateNextImage( const ImageInfo *image_info, Image *image );

A description of each parameter follows:

image_info:
  Many of the image default values are set from this structure. For example, filename, compression, depth, background color, and others.
image:
  The image.

# AnimateImages

## Synopsis

    unsigned int AnimateImages( const ImageInfo *image_info, Image *image );

## Description

AnimateImages() repeatedly displays an image sequence to any X window screen. It returns a value other than 0 if successful. Check the exception member of image to determine the reason for any failure.

The format of the AnimateImages method is:

    unsigned int AnimateImages( const ImageInfo *image_info, Image *image );

A description of each parameter follows:

image_info:
  The image info.
image:
  The image.

# AppendImages

## Synopsis

    Image *AppendImages( const Image *image, const unsigned int stack,
                         ExceptionInfo *exception );

## Description

The AppendImages() method takes a set of images and appends them to each other top-to-bottom if the stack parameter is true, otherwise left-to-right.

The format of the AppendImage method is:

    Image *AppendImages( const Image *image, const unsigned int stack,
                         ExceptionInfo *exception );

image:
  The image sequence.
stack:
  A value other than 0 stacks the images top-to-bottom.
exception:
  Return any errors or warnings in this structure.

# AverageImages

## Synopsis

    Image *AverageImages( Image *image, ExceptionInfo *exception );

## Description

The Average() method takes a set of images and averages them together. Each image in the set must have the same width and height. Average() returns a single image with each corresponding pixel component of each image averaged. On failure, a NULL image is returned and exception describes the reason for the failure.

The format of the AverageImage method is:

    Image *AverageImages( Image *image, ExceptionInfo *exception );

A description of each parameter follows:

image:
  The image sequence.
exception:
  Return any errors or warnings in this structure.

# CatchImageException

## Synopsis

    ExceptionType CatchImageException( Image *image );

## Description

CatchImageException() returns if no exceptions are found in the image sequence, otherwise it determines the most severe exception and reports it as a warning or error depending on the severity.

The format of the CatchImageException method is:

    ExceptionType CatchImageException( Image *image );

A description of each parameter follows:

image:
  An image sequence.

# ClipPathImage

## Synopsis

    unsigned int ClipPathImage( Image *image, const char *pathname,
                                const unsigned int inside );

## Description

ClipPathImage() sets the image clip mask based any clipping path information if it exists.

The format of the ClipPathImage method is:

    unsigned int ClipPathImage( Image *image, const char *pathname,
                                const unsigned int inside );

image:
  The image.
pathname:
  name of clipping path resource. If name is preceded by #, use clipping path numbered by name.
inside:
  if non-zero, later operations take effect inside clipping path. Otherwise later operations take effect outside clipping path.

# CloneImage

## Synopsis

    Image *CloneImage( const Image *image, const unsigned long columns,
                       const unsigned long rows, const unsigned int orphan,
                       ExceptionInfo *exception );

## Description

CloneImage() copies an image and returns the copy as a new image object. If the specified columns and rows is 0, an exact copy of the image is returned, otherwise the pixel data is undefined and must be initialized with the SetImagePixels() and SyncImagePixels() methods. On failure, a NULL image is returned and exception describes the reason for the failure.

The format of the CloneImage method is:

    Image *CloneImage( const Image *image, const unsigned long columns,
                       const unsigned long rows, const unsigned int orphan,
                       ExceptionInfo *exception );

image:
  The image.
columns:
  The number of columns in the cloned image.
rows:
  The number of rows in the cloned image.
orphan:
  With a value other than 0, the cloned image is an orphan. An orphan is a stand-alone image that is not assocated with an image list. In effect, the next and previous members of the cloned image is set to NULL.
exception:
  Return any errors or warnings in this structure.

# CloneImageInfo

## Synopsis

    ImageInfo *CloneImageInfo( const ImageInfo *image_info );

## Description

CloneImageInfo() makes a copy of the given image info structure. If NULL is specified, a new image info structure is created initialized to default values.

The format of the CloneImageInfo method is:

    ImageInfo *CloneImageInfo( const ImageInfo *image_info );

A description of each parameter follows:

image_info:
  The image info.

# CycleColormapImage

## Synopsis

    CycleColormapImage( Image *image, const int amount );

## Description

CycleColormap() displaces an image's colormap by a given number of positions. If you cycle the colormap a number of times you can produce a psychodelic effect.

The format of the CycleColormapImage method is:

    CycleColormapImage( Image *image, const int amount );

A description of each parameter follows:

image:
  The image.
amount:
  Offset the colormap this much.

# DescribeImage

## Synopsis

    void DescribeImage( Image *image, FILE *file, const unsigned int verbose );

## Description

DescribeImage() describes an image by printing its attributes to the file. Attributes include the image width, height, size, and others.

The format of the DescribeImage method is:

    void DescribeImage( Image *image, FILE *file, const unsigned int verbose );

A description of each parameter follows:

image:
  The image.
file:
  The file, typically stdout.
verbose:
  A value other than zero prints more detailed information about the image. Values greater than one enable counting the number of colors in the image.

# DestroyImage

## Synopsis

    void DestroyImage( Image *image );

## Description

DestroyImage() dereferences an image, deallocating memory associated with the image if the reference count becomes zero.

The format of the DestroyImage method is:

    void DestroyImage( Image *image );

A description of each parameter follows:

image:
  The image.

# DestroyImageInfo

## Synopsis

    void DestroyImageInfo( ImageInfo *image_info );

## Description

DestroyImageInfo() deallocates memory associated with a ImageInfo structure.

The format of the DestroyImageInfo method is:

    void DestroyImageInfo( ImageInfo *image_info );

A description of each parameter follows:

image_info:
  The image info.

# DisplayImages

## Synopsis

    unsigned int DisplayImages( const ImageInfo *image_info, Image *image );

## Description

DisplayImages() displays an image sequence to any X window screen. It returns a value other than 0 if successful. Check the exception member of image to determine the reason for any failure.

The format of the DisplayImages method is:

    unsigned int DisplayImages( const ImageInfo *image_info, Image *image );

A description of each parameter follows:

image_info:
  The image info.
image:
  The image.

# GetImageClipMask

## Synopsis

    Image *GetImageClipMask( const Image *image, ExceptionInfo *exception );

## Description

GetImageClipMask returns a reference-counted copy of the current image clip mask. This copy must be deallocated using DestroyImage() once it is no longer needed. If the image does not have an associated clip mask, then NULL is returned. Use SetImageClipMask() to add a clip mask to an image, or remove a clip mask.

If a component of the clip mask is set to TransparentOpacity (maximum value) then the corresponding image pixel component will not be updated when SyncImagePixels() is applied. The clip mask may be used to constrain the results of an image processing operation to a region of the image. Regions outside those allowed by the clip mask may be processed, but only pixel quantums allowed by the clip mask will actually be updated.

The clip mask protects the DirectClass pixels and PseudoClass pixel indexes from modification. The clip mask does not protect the image colormap since the image colormap is globally shared by all pixels in a PseudoClass image.

The format of the GetImageClipMask method is

    Image *GetImageClipMask( const Image *image, ExceptionInfo *exception );

A descripton of each parameter follows:

image:
  The image.
exception:
  Reason for failure.

# GetImageDepth

## Synopsis

    unsigned long GetImageDepth( const Image *image, ExceptionInfo *exception );

## Description

GetImageDepth() returns the minimum bit depth of the image required to ensure that data is not lost in the red, green, blue, and opacity, channels. Pixel components are stored in a Quantum, which is 8, 16, or 32 bits depending on the QuantumDepth value set when the software is compiled. GetImageDepth() returns the smallest modulus storage size which supports the scale of the pixel within the range (i.e. no information is lost). As an example, the value one is returned for a black and white image since only one bit of resolution is required to represent a black and white image.

The format of the GetImageDepth method is:

    unsigned long GetImageDepth( const Image *image, ExceptionInfo *exception );

A description of each parameter follows:

image:
  The image.
exception:
  Return any errors or warnings in this structure.

# GetImageException

## Synopsis

    void GetImageException( Image *image, ExceptionInfo *exception );

## Description

GetImageException() traverses an image sequence and returns any error more severe than noted by the exception parameter.

The format of the GetImageException method is:

    void GetImageException( Image *image, ExceptionInfo *exception );

A description of each parameter follows:

image:
  Specifies a pointer to a list of one or more images.
exception:
  return the highest severity exception.

# GetImageCharacteristics

## Synopsis

    MagickPassFail GetImageCharacteristics( const Image *image,
                                            ImageCharacteristics *characteristics,
                                            MagickBool optimize, ExceptionInfo *exception );

## Description

GetImageCharacteristics obtains the basic characteristics of the image and stores the characterisistics in the user provided ImageCharacteristics structure. If optimize is set to MagickTrue, then exhaustive testing of the image pixels is performed (as required). MagickPass is returned if this method executes without error.

The format of the GetImageCharacteristics method is:

    MagickPassFail GetImageCharacteristics( const Image *image,
                                            ImageCharacteristics *characteristics,
                                            MagickBool optimize, ExceptionInfo *exception );

image:
  The image.
characteristics:
  An ImageCharacteristics structure to update.
optimize:
  Inspect image pixels (if required)
exception:
  Any errors are reported here.

# GetImageGeometry

## Synopsis

    int GetImageGeometry( const Image *image, const char *geometry,
                          const unsigned int size_to_fit, RectangleInfo *region_info );

## Description

GetImageGeometry() returns a region as defined by the geometry string with respect to the image and its gravity.

The format of the GetImageGeometry method is:

    int GetImageGeometry( const Image *image, const char *geometry,
                          const unsigned int size_to_fit, RectangleInfo *region_info );

flags:
  Method GetImageGeometry returns a bitmask that indicates which of the four values were located in the geometry string.
geometry:
  The geometry (e.g. 100x100+10+10).
size_to_fit:
  A value other than 0 means to scale the region so it fits within the specified width and height.
region_info:
  The region as defined by the geometry string with respect to the image and its gravity.

# GetImageInfo

## Synopsis

    void GetImageInfo( ImageInfo *image_info );

## Description

GetImageInfo() initializes image_info to default values.

The format of the GetImageInfo method is:

    void GetImageInfo( ImageInfo *image_info );

A description of each parameter follows:

image_info:
  The image info.

# GetImageStatistics

## Synopsis

    MagickPassFail GetImageStatistics( const Image *image,
                                       ImageStatistics *statistics ExceptionInfo *exception );

## Description

GetImageStatistics computes common statistics (currently maximum, minimum, mean and standard deviation) for the available image channels. The per-channel values are returned in an ImageStatistics structure. Statistics are normalized to the range 0.0 to 1.0. Multiply values by MaxRGB to obtain the statistics in quantum units. Statistics for non-existent channels are set to zero.

The format of the GetImageStatistics method is:

    MagickPassFail GetImageStatistics( const Image *image,
                                       ImageStatistics *statistics ExceptionInfo *exception );

image:
  The image.
statistics:
  An ImageStatistics structure to update with statistics.
exception:
  Any errors are reported here.

# GetImageType

## Synopsis

    ImageType GetImageType( const Image *image, ExceptionInfo *exception );

## Description

GetImageType() returns the type of image:

Bilevel Grayscale GrayscaleMatte Palette PaletteMatte TrueColor TrueColorMatte ColorSeparation ColorSeparationMatte

The format of the GetImageType method is:

    ImageType GetImageType( const Image *image, ExceptionInfo *exception );

A description of each parameter follows:

image:
  The image.
exception:
  Return any errors or warnings in this structure.

# IsTaintImage

## Synopsis

    unsigned int IsTaintImage( const Image *image );

## Description

IsTaintImage() returns a value other than 0 if any pixel in the image has been altered since it was first constituted.

The format of the IsTaintImage method is:

    unsigned int IsTaintImage( const Image *image );

A description of each parameter follows:

image:
  The image.

# ModifyImage

## Synopsis

    ModifyImage( Image *image, ExceptionInfo *exception );

## Description

ModifyImage() ensures that there is only a single reference to the image to be modified, updating the provided image pointer to point to a clone of the original image if necessary.

The format of the ModifyImage method is:

    ModifyImage( Image *image, ExceptionInfo *exception );

A description of each parameter follows:

image:
  The image.
exception:
  Return any errors or warnings in this structure.

# PlasmaImage

## Synopsis

    unsigned int PlasmaImage( Image *image, const SegmentInfo *segment,
                              unsigned long attenuate, unsigned long depth );

## Description

PlasmaImage() initializes an image with plasma fractal values. The image must be initialized with a base color and the random number generator seeded before this method is called.

The format of the PlasmaImage method is:

    unsigned int PlasmaImage( Image *image, const SegmentInfo *segment,
                              unsigned long attenuate, unsigned long depth );

image:
  The image.
segment:
  Define the region to apply plasma fractals values.
attenuate:
  Define the plasma attenuation factor.
depth:
  Limit the plasma recursion depth.

# ReferenceImage

## Synopsis

    Image *ReferenceImage( Image *image );

## Description

ReferenceImage() increments the reference count associated with an image returning a pointer to the image.

The format of the ReferenceImage method is:

    Image *ReferenceImage( Image *image );

A description of each parameter follows:

image:
  The image.

# RemoveDefinitions

## Synopsis

    void RemoveDefinitions( ImageInfo *image_info, const char *options );

## Description

RemoveDefinitions() removes definitions from the current map of definitions in ImageInfo. Definitions may be used by coders/decoders that read and write images. RemoveDefinitions() returns true only if the specified keys are present in the map and are actually removed.

The format of the RemoveDefinitions method is:

    void RemoveDefinitions( ImageInfo *image_info, const char *options );

A description of each parameter follows:

image_info:
  The image info.
keys:
  List of keys to remove from the definitions map. The format of the string is "key1,key2,...". A special key, '*', removes all the key/value pairs in the definitions map. This key always succeeds.
exception:
  Errors result in updates to this structure.

# ReplaceImageColormap

## Synopsis

    MagickPassFail ReplaceImageColormap( Image *image, const PixelPacket *colormap,
                                         const unsigned int colors );

## Description

ReplaceImageColormap() replaces an existing image colormap with a new image colormap. The new image colormap is expected to contain all of the colors from the existing colormap. The existing colormap indexes are adjusted to conform with positions in the new colormap. If the new colormap contains duplicate entries, then the associated colormap index will point to the first entry found in the colormap and other matching entries will not be used. MagickPass is returned if the operation is successful, otherwise MagickFail is returned, and image->exception is updated with the cause of the failure.

This function is useful in case colormap entries need to match across multiple images or otherwise occupy specific locations.

The format of the ReplaceImageColormap method is:

    MagickPassFail ReplaceImageColormap( Image *image, const PixelPacket *colormap,
                                         const unsigned int colors );

image:
  image in which to replace colormap.
colormap:
  new colormap.
colors:
  number of colors in new colormap.

# SetImage

## Synopsis

    void SetImage( Image *image, const Quantum opacity );

## Description

SetImage() sets the red, green, and blue components of each pixel to the image background color and the opacity component to the specified level of transparency. The background color is defined by the background_color member of the image.

The format of the SetImage method is:

    void SetImage( Image *image, const Quantum opacity );

A description of each parameter follows:

image:
  The image.
opacity:
  Set each pixel to this level of transparency.

# SetImageClipMask

## Synopsis

    unsigned int SetImageClipMask( Image *image, const Image *clip_mask );

## Description

SetImageClipMask() associates a clip mask with the image. The clip mask must be the same dimensions as the image.

If a component of the clip mask is set to TransparentOpacity (maximum value) then the corresponding image pixel component will not be updated when SyncImagePixels() is applied. The clip mask may be used to constrain the results of an image processing operation to a region of the image. Regions outside those allowed by the clip mask may be processed, but only pixel quantums allowed by the clip mask will actually be updated.

The clip mask protects the DirectClass pixels and PseudoClass pixel indexes from modification. The clip mask does not protect the image colormap since the image colormap is globally shared by all pixels in a PseudoClass image.

The format of the SetImageClipMask method is:

    unsigned int SetImageClipMask( Image *image, const Image *clip_mask );

A description of each parameter follows:

image:
  The image.
clip_mask:
  The image clip mask.

# SetImageDepth

## Synopsis

    unsigned int SetImageDepth( Image *image, const unsigned long depth );

## Description

SetImageDepth() translates the pixel quantums across all of the channels so that if they are later divided to fit within the specified bit depth, that no additional information is lost (i.e. no remainder will result from the division). Note that any subsequent image processing is likely to increase the effective depth of the image channels. A non-zero value is returned if the operation is successful. Check the exception member of image to determine the cause for any failure.

The format of the SetImageDepth method is:

    unsigned int SetImageDepth( Image *image, const unsigned long depth );

A description of each parameter follows:

image:
  The image to update.
depth:
  Desired image depth (range 1 to QuantumDepth)

# SetImageOpacity

## Synopsis

    void SetImageOpacity( Image *image, const unsigned int opacity );

## Description

SetImageOpacity() attenuates the opacity channel of an image. If the image pixels are opaque, they are set to the specified opacity level. Otherwise, the pixel opacity values are blended with the supplied transparency value.

The format of the SetImageOpacity method is:

    void SetImageOpacity( Image *image, const unsigned int opacity );

A description of each parameter follows:

image:
  The image.
opacity:
  The level of transparency: 0 is fully opaque and MaxRGB is fully transparent.

# SetImageType

## Synopsis

    ( void )SetImageType( Image *image, const ImageType image_type );

## Description

(void) SetImageType() sets the type of image. Choose from these types:

Bilevel Grayscale GrayscaleMatte Palette PaletteMatte TrueColor TrueColorMatte ColorSeparation ColorSeparationMatte OptimizeType

The format of the (void) SetImageType method is:

    ( void )SetImageType( Image *image, const ImageType image_type );

A description of each parameter follows:

image:
  The image.
image_type:
  Image type.

# TextureImage

## Synopsis

    unsigned int TextureImage( Image *image, const Image *texture );

## Description

TextureImage() repeatedly tiles the texture image across and down the image canvas. If the image canvas includes a matte channel, then the tile is alpha-composited "under" the image. MagickFail is returned if an error is encountered.

The format of the TextureImage method is:

    unsigned int TextureImage( Image *image, const Image *texture );

A description of each parameter follows:

image:
  The image.
texture:
  This image is the texture to layer on the background.